import { useMemo } from 'react';
import SuperclusterClass from './Supercluster';
export function useClusterer(data, mapDimensions, region, options) {
  const supercluster = useMemo(() => new SuperclusterClass(options).load(data), [data, options === null || options === void 0 ? void 0 : options.extent, options === null || options === void 0 ? void 0 : options.maxZoom, options === null || options === void 0 ? void 0 : options.minZoom, options === null || options === void 0 ? void 0 : options.minPoints, options === null || options === void 0 ? void 0 : options.radius]);
  const points = useMemo(() => supercluster.getClustersFromRegion(region, mapDimensions), [supercluster, region.latitude, region.longitude, region.latitudeDelta, region.longitudeDelta, mapDimensions.width, mapDimensions.height]);
  return [points, supercluster];
}
//# sourceMappingURL=useClusterer.js.map